/* TICKER
 *
 * by Scott Fial <scott@fial.com> 2010
 *
 * This software is in the public domain and is provided AS IS with NO
 * WARRANTY.
 */

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

typedef char *Glyph[8];

/*   */ static const Glyph G032 = { "     ", "     ", NULL };
/* ! */ static const Glyph G033 = { ": :::", "     ", NULL };
/* " */ static const Glyph G034 = { "  :. ", "   ':", "  :. ", "   ':", "     ", NULL };
/* # */ static const Glyph G035 = { " : : ", ":::::", " : : ", ":::::", " : : ", "     ", NULL };
/* $ */ static const Glyph G036 = { ": .:.", ":':.:", "':' :", "     ", NULL };
/* % */ static const Glyph G037 = { ":.  :", " ':. ", ":  ':", "     ", NULL };
/* & */ static const Glyph G038 = { ".:.:.", ": : :", ": . '", "'::  ", "  :  ", NULL };
/* ' */ static const Glyph G039 = { "  :::", "     ", NULL };
/* ( */ static const Glyph G040 = { ".:::.", "'   '", "     ", NULL };
/* ) */ static const Glyph G041 = { ".   .", "':::'", "     ", NULL };
/* * */ static const Glyph G042 = { ". : .", " ':' ", ".':'.", "  '  ", NULL };
/* + */ static const Glyph G043 = { "  :  ", ":::::", "  :  ", "     ", NULL };
/* , */ static const Glyph G044 = { ".    ", "'::  ", "     ", NULL };
/* - */ static const Glyph G045 = { "  :  ", "  :  ", "     ", NULL };
/* . */ static const Glyph G046 = { "::   ", "     ", NULL };
/* / */ static const Glyph G047 = { ":.   ", " ':. ", "   ':", "     ", NULL };
/* 0 */ static const Glyph G048 = { ".:::.", ":   :", "':::'", "     ", NULL };
/* 1 */ static const Glyph G049 = { ":  . ", ":::::", ":    ", "     ", NULL };
/* 2 */ static const Glyph G050 = { "::. :", ": : :", ": ':'", "     ", NULL };
/* 3 */ static const Glyph G051 = { ": . :", ": : :", "':':'", "     ", NULL };
/* 4 */ static const Glyph G052 = { "  :::", "  :  ", ":::::", "     ", NULL };
/* 5 */ static const Glyph G053 = { ": :::", ": : :", "':' :", "     ", NULL };
/* 6 */ static const Glyph G054 = { ".:::.", ": : :", "':' '", "     ", NULL };
/* 7 */ static const Glyph G055 = { "    :", "::. :", "  '::", "     ", NULL };
/* 8 */ static const Glyph G056 = { ".:.:.", ": : :", "':':'", "     ", NULL };
/* 9 */ static const Glyph G057 = { ". .:.", ": : :", "':::'", "     ", NULL };
/* : */ static const Glyph G058 = { " : : ", "     ", NULL };
/* ; */ static const Glyph G059 = { ":.   ", " ': :", "     ", NULL };
/* < */ static const Glyph G060 = { " .:. ", ":' ':", "     ", NULL };
/* = */ static const Glyph G061 = { " : : ", " : : ", " : : ", "     ", NULL };
/* > */ static const Glyph G062 = { ":. .:", " ':' ", "     ", NULL };
/* ? */ static const Glyph G063 = { "    .", ": : :", "  ':'", "     ", NULL };
/* @ */ static const Glyph G064 = { ".:::.", ":   :", ": : :", ": ':'", "     ", NULL };
/* A */ static const Glyph G065 = { "::::.", "  : :", "::::'", "     ", NULL };
/* B */ static const Glyph G066 = { ":::::", ": : :", "':':'", "     ", NULL };
/* C */ static const Glyph G067 = { ".:::.", ":   :", ":   :", "     ", NULL };
/* D */ static const Glyph G068 = { ":::::", ":   :", "':::'", "     ", NULL };
/* E */ static const Glyph G069 = { ":::::", ": : :", ": ' :", "     ", NULL };
/* F */ static const Glyph G070 = { ":::::", "  : :", "  ' :", "     ", NULL };
/* G */ static const Glyph G071 = { ".:::.", ": . :", "::: '", "  '  ", NULL };
/* H */ static const Glyph G072 = { ":::::", "  :  ", ":::::", "     ", NULL };
/* I */ static const Glyph G073 = { ".   .", ":::::", "'   '", "     ", NULL };
/* J */ static const Glyph G074 = { ".:   ", ":    ", "'::::", "     ", NULL };
/* K */ static const Glyph G075 = { ":::::", " .:. ", ":' ':", "     ", NULL };
/* L */ static const Glyph G076 = { ":::::", ":    ", "'    ", NULL };
/* M */ static const Glyph G077 = { ":::::", " .:' ", " ':. ", ":::::", "     ", NULL };
/* N */ static const Glyph G078 = { ":::::", " .:' ", ":::::", "     ", NULL };
/* O */ static const Glyph G079 = { ".:::.", ":   :", "':::'", "     ", NULL };
/* P */ static const Glyph G080 = { ":::::", "  : :", "  ':'", "     ", NULL };
/* Q */ static const Glyph G081 = { ".:::.", ":.  :", "::::'", "'    ", NULL };
/* R */ static const Glyph G082 = { ":::::", "  : :", "::':'", "     ", NULL };
/* S */ static const Glyph G083 = { ": .:.", ": : :", "':' :", "     ", NULL };
/* T */ static const Glyph G084 = { "    :", ":::::", "    :", "     ", NULL };
/* U */ static const Glyph G085 = { ".::::", ":    ", "'::::", "     ", NULL };
/* V */ static const Glyph G086 = { " .:::", "::   ", " ':::", "     ", NULL };
/* W */ static const Glyph G087 = { ":::::", "':.  ", ".:'  ", ":::::", "     ", NULL };
/* X */ static const Glyph G088 = { ":. .:", " ':' ", ".:':.", "'   '", NULL };
/* Y */ static const Glyph G089 = { "  .::", ":::  ", "  '::", "     ", NULL };
/* Z */ static const Glyph G090 = { ":.  :", ":':.:", ":  ':", "     ", NULL };
/* [ */ static const Glyph G091 = { ":::::", ":   :", "     ", NULL };
/* \ */ static const Glyph G092 = { "   .:", " .:' ", ":'   ", "     ", NULL };
/* ] */ static const Glyph G093 = { ":   :", ":::::", "     ", NULL };
/* ^ */ static const Glyph G094 = { "  :. ", "   ::", "  :' ", "     ", NULL };
/* _ */ static const Glyph G095 = { ":    ", ":    ", ":    ", NULL };
/* ` */ static const Glyph G096 = { "   .:", "  :' ", "     ", NULL };
/* { */ static const Glyph G123 = { "  :  ", ":::::", ":   :", "     ", NULL };
/* | */ static const Glyph G124 = { ":::::", "     ", NULL };
/* } */ static const Glyph G125 = { ":   :", ":::::", "  :  ", "     ", NULL };
/* ~ */ static const Glyph G126 = { "  '. ", "   ::", "  :: ", "   '.", "     ", NULL };

static const Glyph *glyphs[] = {
  &G032, &G032, &G032, &G032, &G032, &G032, &G032, &G032,
  &G032, &G032, &G032, &G032, &G032, &G032, &G032, &G032,
  &G032, &G032, &G032, &G032, &G032, &G032, &G032, &G032,
  &G032, &G032, &G032, &G032, &G032, &G032, &G032, &G032,
  &G032, &G033, &G034, &G035, &G036, &G037, &G038, &G039,
  &G040, &G041, &G042, &G043, &G044, &G045, &G046, &G047,
  &G048, &G049, &G050, &G051, &G052, &G053, &G054, &G055,
  &G056, &G057, &G058, &G059, &G060, &G061, &G062, &G063,
  &G064, &G065, &G066, &G067, &G068, &G069, &G070, &G071,
  &G072, &G073, &G074, &G075, &G076, &G077, &G078, &G079,
  &G080, &G081, &G082, &G083, &G084, &G085, &G086, &G087,
  &G088, &G089, &G090, &G091, &G092, &G093, &G094, &G095,
  &G096, &G065, &G066, &G067, &G068, &G069, &G070, &G071,
  &G072, &G073, &G074, &G075, &G076, &G077, &G078, &G079,
  &G080, &G081, &G082, &G083, &G084, &G085, &G086, &G087,
  &G088, &G089, &G090, &G123, &G124, &G125, &G126, &G032,
};

/* globals */
static char *progname  = "ticker";
static int   delay_ms  = 75;
static int   lines     = 0;
static char *prefix    = "";
static char *suffix    = "";
static char *version   = "1.0 by Scott Fial 2010";

/* is_opt - return true if arg matches short or long opt name */
int is_opt(char *arg, char *s, char *l) {
  return strcmp(arg, s) == 0 || strcmp(arg, l) == 0;
}

/* usage - print usage and quit */
void usage (FILE *f, int exit_code) {
  fprintf(
      f,
      "Usage: %s [OPTIONS] [<message> ...]\n"
      "\n"
      "  -d, --delay <ms>     delay <ms> between lines (default 75)\n"
      "  -h, --help           display help message and exit\n"
      "  -l, --lines <n>      pad output to exactly <n> lines\n"
      "  -p, --prefix <s>     prefix each output line with <s>\n"
      "  -s, --suffix <s>     suffix each output line with <s>\n"
      "  -v, --version        print version info and exit\n"
      "  --                   stop processing options\n"
      "  <message> ...        message to print (else read stdin)\n"
      "\n"
      "Generates vertical scrolling \"stock ticker\" style output on the console.\n\n",
      progname
  );
  exit(exit_code);
}

/* line_out - print a line and optionally delay */
void line_out (char *line) {
  lines--;
  printf("%s%s%s\n", prefix, line, suffix);
  if (delay_ms > 0)
    usleep(delay_ms * 1000);
}

/* print_glyph - output multiple lines for char c */
void print_glyph (char c) {
  const Glyph *g = glyphs[c < 128 ? c : 32];
  int i;
  for (i = 0; (*g)[i]; i++)
    line_out((*g)[i]);
}

/* main */
int main(int argc, char *argv[]) {
  int argi;
  char *arg, *param;

  /* process command line options */
  progname = argv[0];
  for (argi = 1; argi < argc && argv[argi][0] == '-'; argi++) {
    param = argi + 1 < argc ? argv[argi + 1] : NULL;
    arg = argv[argi];
    if (is_opt(arg, "-d", "--delay") && param) {
      delay_ms = atoi(param);
      argi++;
    }
    else if (is_opt(arg, "-h", "--help"))
      usage(stdout, 0);
    else if (is_opt(arg, "-l", "--lines") && param) {
      lines = atoi(param);
      argi++;
    }
    else if (is_opt(arg, "-p", "--prefix") && param) {
      prefix = param;
      argi++;
    }
    else if (is_opt(arg, "-s", "--suffix") && param) {
      suffix = param;
      argi++;
    }
    else if (is_opt(arg, "-v", "--version")) {
      printf("%s %s\n", progname, version);
      exit(0);
    }
    else if (strcmp(arg, "--") == 0) {
      argi++;
      break;
    }
    else
      usage(stderr, 1);
  }

  /* if there are more args, read message from command line */
  if (argi < argc) {
    while (argi < argc) {
      for (arg = argv[argi]; *arg; arg++)
        print_glyph(*arg);
      argi++;
      if (argi < argc)
        print_glyph(' ');
    }
  }
  /* otherwise read message from stdin */
  else {
    char c;
    while ((c = getchar()) != EOF)
      print_glyph(c);
  }

  /* output blank lines to pad if needed. note that we omit one
   * line since the terminal will scroll one line */
  while (lines > 1)
    line_out("     ");

  /* return success */
  exit(0);
}
